untyped
global function ScoreboardForTTDMInit

void function ScoreboardForTTDMInit(){
    thread Monitor()
}

void function Monitor(){
    WaitFrame()

    AddCallback_OnScoreboardPlayerUpdate(replaceScoreboard)
}


int function IconIndex() {
    return GetConVarInt("mp_scoreboard_next_index")
}

int function UpdateIconIndex(int index) {
    SetConVarInt("mp_scoreboard_next_index", index)
    return IconIndex()
}



// replace the scoreboard
void function replaceScoreboard(entity player, int index, int team, SuperiorFile file)
{
	var elemTable = file.playerElems[team][index]
	var rui = Hud_GetRui( elemTable.background )

	for(int i = 0; i < 6; i++) //clearing extra icons
	{
		RuiSetImage( rui, "extraIcon" + i, $"" )
	}

	if(IsAlive(player))
	{
		//Logger.Info("alive")
		entity soul = GetSoulFromPlayer(player)
		entity titan = null
		asset titanIcon
		int currentExtraIconIndex = 0

		if(player.IsTitan())
		{
			titan = soul.GetTitan()
			//Logger.Info(GetTitanCharacterName(titan))
			titanIcon = GetIconForTitanClass(GetTitanCharacterName(titan))
			// class
			RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, titanIcon )


            // only server can have everyones loadouts
			// TitanLoadoutDef loadout = GetTitanLoadoutForPlayer( player ) // GetTitanLoadoutForPlayer not work
			// TitanLoadoutDef loadout = GetTitanLoadoutForPlayer( player )
			// kit1
			// print("kit1 " + GetItemName( loadout.passive1 ))
			// RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetItemImage( loadout.passive1 ) )

			// kit2
			// print("kit2 " + GetItemName( loadout.passive2 ) )
			// RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetItemImage( loadout.passive2 ) )

			if (PlayerHasWeapon(player, "mp_titanability_electric_smoke")) {
				// print("electric_smoke " +  GetItemName( loadout.passive3 ) )
				RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, $"rui/titan_loadout/tactical/titan_tactical_electric_smoke" )
            }

			if (IsCoreChargeAvailable(player, player.GetTitanSoul())) {
				// print("core ready " +  GetItemName( loadout.passive3 ) )
				entity weapon = player.GetOffhandWeapon( OFFHAND_EQUIPMENT )
				RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetWeaponInfoFileKeyFieldAsset_WithMods_Global( weapon.GetWeaponClassName(), weapon.GetMods(), "hud_icon" ))
            }

			// hat
			// print("kit3 " +  GetItemName( loadout.passive3 ) )
			// RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetItemImage( loadout.passive3 ) )

			// // hat
			// print("loadout.antirodeo " +  GetItemName( loadout.passive3 ) )
			// RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetItemImage( loadout.antirodeo ) )

			// // smoke
			// print("loadout.special " +  GetItemName( loadout.special ) )
			// RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetItemImage( loadout.special ) )

			// print("loadout.primaryMod  " +  GetItemName( loadout.special ) )
			// RuiSetImage( rui, "extraIcon" + currentExtraIconIndex++, GetItemImage( loadout.primaryMod  ) )

            UpdateIconIndex(currentExtraIconIndex)

		}
	}
}