untyped
global function ScoreboardGenDisplayInit

void function ScoreboardGenDisplayInit(){
    thread Monitor()
}

void function Monitor(){
    WaitFrame()

    AddCallback_OnScoreboardPlayerUpdate(replaceScoreboard)
}

bool function ShouldShowGenIcon() {
    return strip(GetConVarString("mp_scoreboard_gen_display_show_icon")).tolower() == "true" ? true : false
}

int function GenIconIndex() {
    return GetConVarInt("mp_scoreboard_gen_display_index")
}


string function GenHandledNameMode(entity player) {
    string gen = PlayerXPDisplayGenAndLevel(player.GetGen(), player.GetLevel()) + " "
    switch (GetConVarString("mp_scoreboard_gen_display_handle_name")) {
        case "replace":
            return gen + player.GetPlayerName();
        case "concat":
            return gen + player.GetPlayerNameWithClanTag();
        default:
            break
    }
    return player.GetPlayerNameWithClanTag();
}

bool function IsTLVEnable() {
    try {
      string value = GetConVarString("enable_primaries_display")
        return true;
    } catch (exception){

    }
    return false;
}

// replace the scoreboard
void function replaceScoreboard(entity player, int index, int team, SuperiorFile file)
{
	var elemTable = file.playerElems[team][index]

	var rui = Hud_GetRui( elemTable.background )

    if (ShouldShowGenIcon()) {
        // find empty slot
        // int index = 0;
        int index = 0

        // print("IsTLVEnable() " + IsTLVEnable())
        if (IsAlive(player)) {
            if (player.IsTitan() )
            {
                if (IsTLVEnable()) {
                    index = 1;
                }
            }
            else
            {
                if (IsTLVEnable()) {
                    index = 5;
                }
            }
        }


        if (index < 6) {
        RuiSetImage( rui, "extraIcon" + index, GetPlayerGenIcon( player ) )
        }
    }
    RuiSetString(rui, "playerName", GenHandledNameMode(player) )
}

asset function GetPlayerGenIcon( entity player )
{
	int gen = player.GetGen()
	return gen < 10 ? GetGenIcon(10) : GetGenIcon(gen)
}